// IBIS control software for WinNT (04/09/02)
// modified for recording whole SPR curves 03/03
#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

#include <time.h>

#undef debug

HANDLE  idComDev ;
DWORD dwBytesRecd,dwBytesWritten;

void send_cmd(char *s)
{int n=0;
 char aa[5000];                    // max command length !
 while (s[n]!=0)
   {
#ifdef debug
	 if ((s[n]==13)||(s[n]==10)) printf(" "); else printf("%c",s[n]);
#endif
	aa[n]=s[n];
    if (s[n]=='_') aa[n]=13; 
    if (s[n]==10) aa[n]=13; // unix/DOS files: chr10 for end of line
	if (s[n]==13) n--;      // if it's a DOS file, rm chr(13)
    n++;
   }
 aa[n]=13;                  // trailing character
 WriteFile(idComDev,aa,n,&dwBytesWritten,0);fflush(stdout);
#ifdef debug
 printf("\n\n");
#endif
}

void send_file(char *s)
{int n=0,res=EOF+1;FILE *f;
 char aa[5000],cc;                    // max command length !
 f=fopen(s,"r");
 while (res!=EOF)
 //  {res=fscanf(f,"%d",&c);aa[n]=c;n++;
 //   if (aa[n-1]==13) printf("\n"); else printf("%c",(char)c&0xff);
   {res=fscanf(f,"%c",&cc);
    if ((cc==13)||(cc==10)) printf(" "); else printf("%c",cc);
	aa[n]=cc;
    if (cc==32) aa[n]=13; 
    if (cc==10) aa[n]=13; // unix/DOS files: chr10 for end of line
	if (cc==13) n--;      // if it's a DOS file, rm chr(13)
    n++;
   }
 WriteFile(idComDev,aa,n-1,&dwBytesWritten,0);fflush(stdout);
 printf("\n\n");fclose(f);
}

int main(int argc, char* argv[])
{DCB dcb;COMMTIMEOUTS cmm;
 BYTE abIn[2]; int cnt;unsigned int res1[200],res2[200],min,minp;
 FILE *flog,*fmin;
 char c1,c2,c3,c4; 
 time_t clock1,clock2;

 printf("CHECK THAT IBIS IS CONNECTED TO COM1\n");
 idComDev=CreateFile("COM1", GENERIC_READ | GENERIC_WRITE,1,NULL,      
            OPEN_EXISTING,0,NULL ); // 0=NO overlapped IO
 dcb.DCBlength = sizeof( DCB ) ;
 GetCommState(idComDev, &dcb ) ;
 dcb.BaudRate=9600 ;
 dcb.ByteSize=8;
 dcb.Parity=NOPARITY;
 dcb.StopBits=ONESTOPBIT;
 SetCommState( idComDev, &dcb ) ;

 GetCommTimeouts(idComDev, &cmm ) ;
 cmm.ReadIntervalTimeout=100;
 cmm.ReadTotalTimeoutConstant=100;
 cmm.ReadTotalTimeoutMultiplier=100;
 cmm.WriteTotalTimeoutConstant=100;
 cmm.WriteTotalTimeoutMultiplier=100;
 SetCommTimeouts(idComDev, &cmm) ;
 
/*
 ReadFile(idComDev,abIn,1,&dwBytesRecd,0);    // blocking read ... until timeout
 if (dwBytesRecd==1) printf("%d=%c \n",(int)abIn[0],(char)abIn[0]);
    else printf("Timeout ... \n");           // dwBytesRecd=0 if timeout else =1
*/

 do ReadFile(idComDev,abIn,1,&dwBytesRecd,0); // empty UART buffer
 while (dwBytesRecd!=0);
 // send_file("initia1.asc");

 /*****************************************************************/
 // INITIALIZATION STEPS 
 send_file("initia2a.txt");

 ReadFile(idComDev,abIn,1,&dwBytesRecd,0);printf("%c",(char)abIn[0]); // read 'I'
 printf("\n");
 // send_file("initia2.asc");
 send_file("initia2b.txt");

 printf("Watch the seringes move ...\n");
 do	ReadFile(idComDev,abIn,1,&dwBytesRecd,0); // read 'i'+'Y...'
 while((char)abIn[0]!='Y'); printf("%c",(char)abIn[0]);
 for (cnt=0;cnt<6;cnt++) // we get the 6 chars after the 'Y' & print them
	{ReadFile(idComDev,abIn,1,&dwBytesRecd,0);printf("%c",(char)abIn[0]);}
 printf("\n");
 // send_file("initia3.asc");
 send_file("initia2c.txt");
 /*****************************************************************/

  flog=fopen("log.asc","w");fmin=fopen("min.asc","w");
 /*****************************************************************/
 // SEND COMMAND REQUESTING CURVE (G3) AND STORE / PROCESS
 time(&clock1);
 while (1) {
	 do {ReadFile(idComDev,abIn,1,&dwBytesRecd,0); // read 'TA????'
#ifdef debug
	     printf("%c",abIn[0]);  
#endif
		}                  // empty buffer
   while (dwBytesRecd!=0);
#ifdef debug
   printf("\n");
#endif
   send_cmd("G_3_");
   do ReadFile(idComDev,abIn,1,&dwBytesRecd,0); // read until beginning of
   while ((char)abIn[0]!='S');                  // curve
   printf("reading curve ... ");fflush(stdout);
   time(&clock2);
   for (cnt=0;cnt<200;cnt++)
   {ReadFile(idComDev,abIn,1,&dwBytesRecd,0);c1=(char)abIn[0];
    ReadFile(idComDev,abIn,1,&dwBytesRecd,0);c2=(char)abIn[0];
    ReadFile(idComDev,abIn,1,&dwBytesRecd,0);c3=(char)abIn[0];
    ReadFile(idComDev,abIn,1,&dwBytesRecd,0);c4=(char)abIn[0];
    if (c1>64) c1-=55;else c1-=48;if (c2>64) c2-=55;else c2-=48;
    if (c3>64) c3-=55;else c3-=48;if (c4>64) c4-=55;else c4-=48;
	res1[cnt]=(((c1*16)+c2)*16+c3)*16+c4;
   }
   printf("c1 read ");fflush(stdout);
   ReadFile(idComDev,abIn,1,&dwBytesRecd,0); // remove 'V'
   for (cnt=0;cnt<200;cnt++)
   {ReadFile(idComDev,abIn,1,&dwBytesRecd,0);c1=(char)abIn[0];
    ReadFile(idComDev,abIn,1,&dwBytesRecd,0);c2=(char)abIn[0];
    ReadFile(idComDev,abIn,1,&dwBytesRecd,0);c3=(char)abIn[0];
    ReadFile(idComDev,abIn,1,&dwBytesRecd,0);c4=(char)abIn[0];
    if (c1>64) c1-=55;else c1-=48;if (c2>64) c2-=55;else c2-=48;
    if (c3>64) c3-=55;else c3-=48;if (c4>64) c4-=55;else c4-=48;
	res2[cnt]=(((c1*16)+c2)*16+c3)*16+c4;
   }
   min=65535;minp=0;
   for (cnt=0;cnt<200;cnt++) 
	{fprintf(flog,"%u ",res1[cnt]);if (res1[cnt]<min) {min=res1[cnt];minp=cnt;}}
   fprintf(flog,"\n");printf("min1=[%u,%u] ",minp,min);
   fprintf(fmin,"%ld %u %u ",clock2-clock1,minp,min);
   min=65535;minp=0;
   for (cnt=0;cnt<200;cnt++) 
	{fprintf(flog,"%u ",res2[cnt]);if (res2[cnt]<min) {min=res2[cnt];minp=cnt;}}
   fprintf(flog,"\n");printf("min2=[%u,%u] ",minp,min);
   fprintf(fmin,"%u %u\n",minp,min);
   fflush(flog); fflush(fmin); printf("DONE\n");
  }

/*
 while (1)
 {printf ("> ");scanf("%s",cmd);send_cmd(cmd);
  fprintf(log,"CMD: %s\n",cmd); // cmd is separated and terminated by '_'
  fflush(log);
  do {ReadFile(idComDev,abIn,1,&dwBytesRecd,0); // empty UART buffer
      printf("%c",abIn[0]);fprintf(log,"%c",abIn[0]);fflush(log);}
  while (dwBytesRecd!=0);
  printf("\n");
 }
 */
 return(0);
}
// if (argc==1) f=fopen("connect.txt","r"); else f=fopen(argv[1],"r");
